Attribute VB_Name = "Module1"
Option Explicit

Public currSortColumn As Long

'Structures
Public objFind As LV_FINDINFO
Public objItem As LV_ITEM
Public sOrder As Boolean

Public Type POINT
x As Long
y As Long
End Type

Public Type LV_FINDINFO
flags As Long
psz As String
lParam As Long
pt As POINT
vkDirection As Long
End Type

'Public Type LV_ITEM
' mask As Long
' iItem As Long
' iSubItem As Long
' state As Long
' stateMask As Long
' pszText As Long
' cchTextMax As Long
' iImage As Long
' lParam As Long
' iIndent As Long
'End Type

Public Type LV_ITEM
mask As Long
iItem As Long
iSubItem As Long
state As Long
stateMask As Long
pszText As String
cchTextMax As Long
iImage As Long
lParam As Long
iIndent As Long
End Type

'Constants
Public Const LVFI_PARAM = 1
Public Const LVIF_TEXT = &H1

Public Const LVM_FIRST = &H1000
Public Const LVM_FINDITEM = LVM_FIRST + 13
Public Const LVM_GETITEMTEXT = LVM_FIRST + 45
Public Const LVM_SORTITEMS = LVM_FIRST + 48

'API declarations
'Public Declare Function SendMessageLong Lib "user32" Alias "SendMessageA"( _
ByVal hWnd As Long, _
ByVal wMsg As Long, _
ByVal wParam As Long, _
ByVal lParam As Long) As Long

'Public Declare Function SendMessageAny Lib "user32" Alias "SendMessageA"( _
ByVal hWnd As Long, _
ByVal wMsg As Long, _
ByVal wParam As Long, _
lParam As Any) As Long

'bylo to
Public Declare Function SendMessage Lib "user32" _
Alias "SendMessageA" _
(ByVal hWnd As Long, _
ByVal wMsg As Long, _
ByVal wParam As Long, _
lParam As Any) As Long

'jest to
Public Declare Function SendMessageW Lib "user32" ( _
   ByVal hWnd As Long, _
   ByVal wMsg As Long, _
   ByVal wParam As Long, _
   lParam As Any) As Long

Public Function CompareValues(ByVal lParam1 As Long, ByVal lParam2 As Long, ByVal hWnd As Long) As Long

'CompareValues: This is the sorting routine that gets passed to the
'ListView control to provide the comparison test for numeric values.

'Compare returns:
' 0 = Less Than
' 1 = Equal
' 2 = Greater Than

Dim val1 As Single
Dim val2 As Single

'Obtain the item names and dates corresponding
'to the input parameters
val1 = ListView_GetItemValueStr(hWnd, lParam1)
val2 = ListView_GetItemValueStr(hWnd, lParam2)

'based on the Public variable sOrder set in the
'columnheader click sub, sort the dates appropriately:
Select Case sOrder
Case True: 'sort decending

If val1 < val2 Then
CompareValues = 0
ElseIf val1 = val2 Then
CompareValues = 1
Else: CompareValues = 2
End If

Case Else: 'sort ascending

If val1 > val2 Then
CompareValues = 0
ElseIf val1 = val2 Then
CompareValues = 1
Else: CompareValues = 2
End If

End Select

End Function

Public Function ListView_GetItemValueStr(hWnd As Long, lParam As Long) As Single

Dim r As Long
Dim hIndex As Long

'Convert the input parameter to an index in the list view
objFind.flags = LVFI_PARAM
objFind.lParam = lParam
hIndex = SendMessageW(hWnd, LVM_FINDITEM, -1, objFind)

'Obtain the value of the specified list view item.
'The objItem.iSubItem member is set to the index
'of the column that is being retrieved.
objItem.mask = LVIF_TEXT
objItem.iSubItem = currSortColumn
objItem.pszText = Space$(32)
objItem.cchTextMax = Len(objItem.pszText)

'get the string at subitem currSortColumn
r = SendMessageW(hWnd, LVM_GETITEMTEXT, hIndex, objItem)

'and convert it into a long
If r > 0 Then
ListView_GetItemValueStr = CSng(Left$(objItem.pszText, r))
End If

End Function

Public Function FARPROC(ByVal pfn As Long) As Long

'A procedure that receives and returns
'the value of the AddressOf operator.
'This workaround is needed as you can't assign
'AddressOf directly to an API when you are also
'passing the value ByVal in the statement
'(as is being done with SendMessageW)

FARPROC = pfn

End Function

